#coding: utf-8

from m3.db import BaseEnumerate

# Последовательность полей на форме соответствует последовательности в кортеже
# ((<fieldset>, (<fieldset_description>, (<field>, ...))), ...)
# ((<field>, <field_description>), ...)
ATTRIBUTES_FIELDS_MAP = (
    ('birthplace', (u"Место рождения", (
        'country',
        'region',
        'city'
    ))),
    ('personal_number', u"Личный номер"),
    ('force_kind', u"Принадлежность к виду или роду войск"),
    ('military_unit', u"Воинская часть (Подразделение)"),
    ('dismissal_date', u"Дата увольнения"),
    ('rank', u"Звание")
)

PRIVILEGE_CONFIRMATION_STATUSES_MAP = {
    True: u"Подтверждена",
    False: u"Не подтверждена"
}

# Шаблон сообщения о постановки детей в очередь
CHILDREN_APPLY_IN_QUEUE_TMP = (
    u"Ваш ребенок поставлен на учет. Регистрационный номер ({client_id})")


class DepartmentAttribute(BaseEnumerate):
    @classmethod
    def generate(cls):
        # Формируем Enum динамически
        for field, description in ATTRIBUTES_FIELDS_MAP:
            if isinstance(description, tuple):
                # Если fieldset
                description, _ = description

            setattr(cls, field.upper(), field)
            cls.values.update({field: description})

DepartmentAttribute.generate()


NOTIFICATION_MODE = {
    'WANT_CHANGE_DOU': 1,
    'IN_QUEUE': 2,
    'REJECT': 3
}


class ReturnReasonEnum(BaseEnumerate):
    SHORT_STAY_GROUP = 0
    NOT_STATED_DOU = 1
    CHANGE_DATE = 2
    values = {
        SHORT_STAY_GROUP: u'Предоставлением ранее места в'
                          u' группе кратковременного пребывания детей',
        NOT_STATED_DOU: u'Предоставлением ранее места в незаявленной ОО',
        CHANGE_DATE: u'Изменения срока  предоставления места в ОО'
    }
